//***************************************************************************
//                          main.cpp  -  description
//                             -------------------
//  begin            : Mi. Okt 20 08:43:44 2010
//  generated by     : pvdevelop (C) Lehrig Software Engineering
//  email            : lehrig@t-online.de
//***************************************************************************
#include "pvapp.h"
// todo: comment me out. you can insert these objects as extern in your masks.
//rlModbusClient     modbus(modbusdaemon_MAILBOX,modbusdaemon_SHARED_MEMORY,modbusdaemon_SHARED_MEMORY_SIZE);
//rlSiemensTCPClient siemensTCP(siemensdaemon_MAILBOX,siemensdaemon_SHARED_MEMORY,siemensdaemon_SHARED_MEMORY_SIZE);
//rlPPIClient        ppi(ppidaemon_MAILBOX,ppidaemon_SHARED_MEMORY,ppidaemon_SHARED_MEMORY_SIZE);

//Alarm myalarm(1);   // with event log
Alarm myalarm;        // without event log
rlThread thread;

static void *cyclic_actions(void *arg)
{
  THREAD_PARAM *p = (THREAD_PARAM *) arg;
  printf("cyclic_actions start\n");

  while(p->running)
  {
    printf("before myalarm(A1).isSet=%d\n", myalarm.isSet("A1"));
    myalarm.set("A1");
    myalarm.setInt("A2", 1);
    myalarm.setFloat("A3", 1.234f);
    printf("after myalarm(A1).isSet=%d\n", myalarm.isSet("A1"));
    printf("myalarm1=%s\n", myalarm.text("A1"));
    printf("myalarm2=%s\n", myalarm.text("A2"));
    printf("myalarm3=%s\n", myalarm.text("A3"));
    rlsleep(3000);
    myalarm.ack("A1");
    rlsleep(2000);
    myalarm.ack("A2");
    rlsleep(2000);
    myalarm.ack("A3");
    rlsleep(2000);
    myalarm.reset("A1");
    rlsleep(2000);
    myalarm.reset("A2");
    rlsleep(2000);
    myalarm.reset("A3");
    rlsleep(2000);
  }

  return arg;
}

int pvMain(PARAM *p)
{
int ret;

  pvSetCaption(p,"pvs");
  pvResize(p,0,1280,1024);
  //pvScreenHint(p,1024,768); // this may be used to automatically set the zoomfactor
  ret = 1;
  pvGetInitialMask(p);
  if(strcmp(p->initial_mask,"mask1") == 0) ret = 1;

  while(1)
  {
    if(trace) printf("show_mask%d\n", ret);
    switch(ret)
    {
      case 1:
        pvStatusMessage(p,-1,-1,-1,"mask1");
        ret = show_mask1(p);
        break;
      default:
        return 0;
    }
  }
}

#ifdef USE_INETD
int main(int ac, char **av)
{
PARAM p;

  pvInit(ac,av,&p);
  /* here you may interpret ac,av and set p->user to your data */
  pvMain(&p);
  return 0;
}
#else  // multi threaded server
int main(int ac, char **av)
{
PARAM p;
int   s;

  // begin user defined code
  if(myalarm.loadCSV("alarm.csv") < 0)          
  {
    printf("could not load alarm.csv\n");
    return -1;
  }
#ifdef unix
  char *argv[] = {"","-eventhost=localhost","-eventport=6003"};
#else
  char *argv[] = {"","-eventhost=localhost","-eventport=5100"};
#endif
  rlEventInit(3,argv,"/TEST/");
  thread.create(cyclic_actions,NULL);         
  // end user defined code

  pvInit(ac,av,&p);
  /* here you may interpret ac,av and set p->user to your data */
  while(1)
  {
    s = pvAccept(&p);
    if(s != -1) pvCreateThread(&p,s);
    else        break;
  }
  return 0;
}
#endif
